#include "cpp_test_processor.h"

#include <cmath>
#include <iostream>

using namespace std;

Processor *g_processor;

int CPPTEST_init()
{
    g_processor = new Processor();

    return 0;
}

void CPPTEST_free()
{
    delete g_processor;
}

void CPPTEST_setImageSize(int width, int height)
{
    g_processor->setImageSize(width, height);
}

void CPPTEST_setImagePixels(float *pixels)
{
    g_processor->setImagePixels(pixels);
}

void CPPTEST_process()
{
    g_processor->process();
}

Processor::Processor() :
    m_imageWidth(0),
    m_imageHeight(0),
    m_imagePixels(NULL)
{
}

Processor::~Processor()
{
}

void Processor::setImageSize(int width, int height)
{
    m_imageWidth = width;
    m_imageHeight = height;
}

void Processor::process()
{
    int x, y;

    for (y = 0; y < m_imageHeight; y++) {
        for (x = 0; x < m_imageWidth; x++) {
            long offset = (m_imageWidth * y + x) * 4;

            float *addr = m_imagePixels + offset;

            float r = (float) cos(x * 0.01);
            float g = (float) sin(y * 0.01);
            float b = (float) cos(x * y * 0.01);

            r = (r + 1.0f) / 2.0f;
            g = (g + 1.0f) / 2.0f;
            b = (b + 1.0f) / 2.0f;

            *addr = r;
            *(addr + 1) = g;
            *(addr + 2) = b;
            *(addr + 3) = 1.0f;
        }
    }
}
