#ifndef CPP_TEST_PROCESSOR_H_
#define CPP_TEST_PROCESSOR_H_

#if defined(_MSC_VER)
    #define EXPORT __declspec(dllexport)
#else
    #define EXPORT
#endif

extern "C" {

EXPORT int CPPTEST_init();
EXPORT void CPPTEST_free();
EXPORT void CPPTEST_setImageSize(int width, int height);
EXPORT void CPPTEST_setImagePixels(float *pixels);
EXPORT void CPPTEST_process();

}

class Processor
{
public:
    Processor();
    virtual ~Processor();
    void setImageSize(int width, int height);
    void setImagePixels(float *pixels) { m_imagePixels = pixels; }
    void process();

private:
    int m_imageWidth;
    int m_imageHeight;
    float *m_imagePixels;
};

#endif // CPP_TEST_PROCESSOR_H_
